/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.kintai.action.AttendanceTotalAction;
import jp.mosp.kintai.dao.MYukyuDao;
import jp.mosp.kintai.dto.MYukyuDto;

import jp.mosp.payroll.dao.CompileAmendmentDao;
import jp.mosp.payroll.dao.MKintaiDao;
import jp.mosp.payroll.dao.MKintaiKeisanDao;
import jp.mosp.payroll.dto.CompileAmendmentDto;
import jp.mosp.payroll.dto.MKintaiDto;
import jp.mosp.payroll.dto.MKintaiKeisanDto;
import jp.mosp.payroll.vo.AttendanceCalculateEndCardVo;

public class AttendanceCalculateEndCardAction extends AttendanceTotalAction {

	// コマンド
	private static final String CMD_CARD_SHOW 	= "P1060";
	private static final String CMD_CARD_UPDATE 	= "P1061";

	/**
	 * コンストラクタ
	 */
	public AttendanceCalculateEndCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmPayrollAuth();
		// VOの取得
		AttendanceCalculateEndCardVo vo = new AttendanceCalculateEndCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		MKintaiKeisanDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MKintaiKeisanDto ? (MKintaiKeisanDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_CARD_SHOW)) {
			vo.setDefaultValues();
			// 表示
			dto = show(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CARD_UPDATE)) {
			// 更新
			dto = update(vo);
			// モード設定
			vo.setMode(AttendanceCalculateEndCardVo.MODE_IMPOSSIBLE);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 設定項目検索
	 * @param vo Voインスタンス
	 * @throws Exception
	 */
	private MKintaiKeisanDto show(AttendanceCalculateEndCardVo vo) throws Exception {
		// DAOの準備
		MKintaiKeisanDao dao = new MKintaiKeisanDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		MKintaiKeisanDto dto = dao.findForCalc();
		if (chkExistDto(dto)) {
			//	dtoがあったら、dtoをVoにセットする。
			vo.setFields(dto);
			// 計算完了の場合
			if (dto.getKKanryou().equals(CommonConst.NUM_ATTENDANCE_CALCULATE_FLAG_ON)) {
				String sikyuym = dto.getKTNen() + CommonConst.STR_UNDER_SEPARATOR + dto.getKTTuki();
				// メッセージ用計算年月
				vo.addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_CALCULATE, sikyuym));
				// モード設定
				vo.setMode(AttendanceCalculateEndCardVo.MODE_IMPOSSIBLE);
			} else {
				// モード設定
				vo.setMode(AttendanceCalculateEndCardVo.MODE_UPDATE);
			}
		} else {
			// 選択年月をセット
			vo.setLblKTnen(String.valueOf(MospUtility.getYear(util.getSystemDate())));
			vo.setLblKTtuki(String.valueOf(MospUtility.getMonth(util.getSystemDate())));
			// 計算情報無し
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
			// モード設定
			vo.setMode(AttendanceCalculateEndCardVo.MODE_IMPOSSIBLE);
		}
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private MKintaiKeisanDto update(AttendanceCalculateEndCardVo vo) throws Exception {
		// DAOの準備
		MKintaiKeisanDao dao = new MKintaiKeisanDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		// 更新する前にdtoが存在するかどうかをチェック
		MKintaiKeisanDto dto = dao.findForUpdate();
		if (chkExistDto(dto)) {
			dto.setKKanryou(CommonConst.NUM_ATTENDANCE_CALCULATE_FLAG_ON);
			// 更新
			dao.update(dto);
			// DTOの再取得
			MKintaiKeisanDto retDto = dao.findForKey(String.valueOf(dto.getKTNen()));
			chkUpdate(retDto);
			// 全所属一覧取得
			String[][] arySections = getSectionArrayAll();
			// コミットフラグ
			boolean[] flagArraySection = new boolean[arySections.length];
			for (int i = 0; i < arySections.length; i++) {
				// 所属在籍社員一覧
				String[] aryAllusers = getBasisArray(arySections[i][0], getCalcAttendance());
				boolean[] flagArrayUsers = new boolean[aryAllusers.length];
				for (int j = 0; j < aryAllusers.length; j++) {
					// 有給繰越処理
					flagArrayUsers[j] = registPaidHolidayCarryForward(aryAllusers[j], vo, retDto);
				}
				// 繰越処理フラグ
				boolean isCarryForward = true;
				for (int j = 0; j < flagArrayUsers.length; j++) {
					if (!flagArrayUsers[j]) {
						isCarryForward = false;
						break;
					}
				}
				if (isCarryForward) {
					flagArraySection[i] = true;
				} else {
					flagArraySection[i] = false;
				}
			}
			// 繰越処理終了フラグ
			boolean isAllCarryForward = true;
			for (int k = 0; k < flagArraySection.length; k++) {
				if (!flagArraySection[k]) {
					isAllCarryForward = false;
					break;
				}
			}
			if (isAllCarryForward) {
				// メッセージ設定
				vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
				// コミット
				commit();				
			} else {
				// 計算完了失敗メッセージ
				vo.setMessage(MospConst.LOG_MSG_1022);
			}
		} else {
			// 計算情報無し
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
		return dto;
	}

	/**
	 * 有給繰越処理
	 * @throws Exception
	 */
	private boolean registPaidHolidayCarryForward(
			String kCode,
			AttendanceCalculateEndCardVo vo,
			MKintaiKeisanDto dto
	) throws Exception {
		// 有給設定情報取得
		boolean isCarryForward = false;
		// 繰越月
		int CFMonth = Integer.parseInt(getPaidHolidayInfo()[0]);
		// 繰越日数
		int CFDays = Integer.parseInt(getPaidHolidayInfo()[1]);
		// 繰越区分
		String CFFlag = getPaidHolidayInfo()[2];
		// パラメータの初期化
		// 前月残日数（当年度分）
		double remainLastThis = 0;
		// 前月残日数（前年度分）
		double remainLastPrev = 0;
		// 使用日数
		double use = 0;
		// 支給日数
		int payment = 0;
		// 破棄日数
		double waste = 0;
		// 当月残日数（当年度分）
		double remainThisThis = 0;
		// 当月残日数（前年度分）
		double remainThisPrev = 0;	
		// DAOの準備
		MKintaiDao 	mKintaiDao 	= new MKintaiDao();
		MYukyuDao 	mYukyuDao 	= new MYukyuDao();
		mKintaiDao.initDao(cfg, cmd, aspUser, user, conn);
		mYukyuDao.initDao(cfg, cmd, aspUser, user, conn);
		// 勤怠集計検索
		String sikyuym = dto.getKTNen() + CommonConst.STR_SEPARATOR + dto.getKTTuki();
		MKintaiDto mKintaiDto = mKintaiDao.findForKey(kCode, sikyuym);
		if (chkExistDto(mKintaiDto)) {
			// 勤怠集計検索
			CompileAmendmentDao cAmendmentDao = new CompileAmendmentDao();
			cAmendmentDao.initDao(cfg, cmd, aspUser, user, conn);
			CompileAmendmentDto cAmendmentDto = cAmendmentDao.findForCondition(
					kCode,
					sikyuym,
					getBelongSectionCode(kCode)
			);
			// 勤怠承認機能有効無効確認
			if (isAttendanceApprovalFunction()) {
				// 未承認有無検索
				if (!checkApproval(cAmendmentDto, getCalcAttendance())) {
					// 未承認データが存在場合
					vo.addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_EXIST_NOT_APPROVED, getKName(kCode)));
					return false;
				}
			}
			// 勤怠集計から使用有給日数を取得
			use = mKintaiDto.getYukyu();
			// 当月の有給情報検索
			String currentDate = util.convIntegerToStringDate(dto.getKSNen(), dto.getKSTuki(), dto.getKShi());
			MYukyuDto currentDto = mYukyuDao.findForKey(kCode, currentDate);
			if (!chkExistDto(currentDto)) {
				currentDto = new MYukyuDto();
				currentDto.setKCode(kCode);
				currentDto.setKyuyoYMD(Integer.parseInt(currentDate));
			}
			// 当月の有休情報の設定
			payment = currentDto.getSyutoku();
			waste = currentDto.getHaiki();
			remainThisThis = currentDto.getTZanT();
			remainThisPrev = currentDto.getTZanZ();
			// 前月の有給情報検索
			String formerDate  = String.valueOf(util.convDateToInteger(
					util.addMonth(util.getDate(dto.getKSNen(), dto.getKSTuki(), dto.getKShi()), -1)));
			MYukyuDto formerDto = mYukyuDao.findForFormer(kCode, formerDate);
			if (!chkExistDto(formerDto)) {
				formerDto = new MYukyuDto();
			}
			// 前月の有給情報の設定
			remainLastThis = formerDto.getTZanT();
			remainLastPrev = formerDto.getTZanZ();
			// 繰り越し処理月だった場合
			if (CFMonth == MospUtility.getMonth(getCalcPayment())) {
				// 繰り越し区分判別
				// 当年のみ
				if (CFFlag.equals(CommonConst.NAM_COMMON_FLAG_OFF)) {
					// 廃棄更新
					// 前々年度分を消化数を引いた分破棄。
					if (remainLastPrev < use) {
						use = Math.abs(remainLastPrev - use);
						waste = 0;
					} else {
						waste = remainLastPrev - use;
						use = 0;
					}
					// 前月前年度分を当月前年度分に移動。
					remainThisPrev = remainLastThis;
				}
				// 合計で繰り越し
				else if (CFFlag.equals(CommonConst.NAM_COMMON_FLAG_ON)) {
					// 前月分を合計して繰越日数分だけ繰り越す。
					if ((remainLastPrev + remainLastThis) >= CFDays) {
						waste = (remainLastPrev + remainLastThis) - CFDays;
					} else {
						waste = 0;
					}
					remainThisPrev = remainLastPrev + remainLastThis - waste;
				}
				// 勤続月数取得
				double yearOfService = getYearsOfService(kCode);
				// 勤続月数から有給支給日数を取得
				String[][] aryPaidHolidayDays = getPaidHolidayArray();
				for (int i = 0; i < aryPaidHolidayDays.length; i++) {
					if (yearOfService >= Integer.parseInt(aryPaidHolidayDays[i][0])) {
						payment = Integer.parseInt(aryPaidHolidayDays[i][1]);
					}
				}
				remainThisThis += payment;
				//有給更新
				if (use <= remainThisPrev) {
					remainThisPrev -= use;
				} else {
					// 当月消化分
					use -= remainThisPrev;
					remainThisPrev = 0;
					remainThisThis -= use;
				}				
			} else {
				//有給取得更新
				remainThisThis += remainLastThis;
				remainThisPrev += remainLastPrev;
				//有給更新
				if (use <= remainThisPrev) {
					remainThisPrev -= use;
				} else {
					// 当月消化分
					use -= remainThisPrev;
					remainThisPrev = 0;
					remainThisThis -= use;
				}
			}
			// DTOにセット
			currentDto.setZZanT(remainLastThis);
			currentDto.setZZanZ(remainLastPrev);
			currentDto.setSyoka(mKintaiDto.getYukyu());
			currentDto.setSyutoku(payment);
			currentDto.setHaiki(waste);
			currentDto.setTZanT(remainThisThis);
			currentDto.setTZanZ(remainThisPrev);
			// 登録
			if (mYukyuDao.findForUpdate(kCode, currentDate) == null) {
				// 登録
				mYukyuDao.insert(currentDto);
			} else {
				// 更新
				mYukyuDao.update(currentDto);
			}
			// 更新チェック
			chkUpdate(mYukyuDao.findForKey(kCode, currentDate));
			isCarryForward = true;
		} else {
			// 勤怠集計データがない場合
			vo.addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_NO_ATTENDANCE_COMPILED, getKName(kCode)));
		}
		return isCarryForward;
	}

}
